#include <jni.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <pthread.h> //vad

#include "distributedMonitor.h"
#include "reportProcessor.h"

extern char* commBuffer[1000];
extern int commElements;
extern pthread_mutex_t lockFile;

JNIEXPORT void JNICALL Java_CommJavaC_startRunning
(JNIEnv *env , jobject obj, jint pid, jint port, jint remote, jint dynamic, jstring filter)
{
	const char* cFilter = (*env)->GetStringUTFChars(env, filter, 0);
	startMonitoring(pid, port, remote, dynamic, cFilter);
}

JNIEXPORT void JNICALL Java_CommJavaC_stopRunning
(JNIEnv *env, jobject obj)
{
	stopMonitoring();
}

JNIEXPORT void JNICALL Java_CommJavaC_lockFileToRead
(JNIEnv * env, jobject obj)
{
	pthread_mutex_lock(&lockFile);
}

JNIEXPORT void JNICALL Java_CommJavaC_unlockFileToRead
(JNIEnv * env, jobject obj)
{
	pthread_mutex_unlock(&lockFile);
}

JNIEXPORT void JNICALL Java_CommJavaC_startOffline
(JNIEnv * env, jobject obj, jobjectArray jarray)
{
	int size = (*env)->GetArrayLength(env, jarray);

	char* paths[size];
	int i = 0;
	int sizeString = 0;

//vad
fprintf(stderr, "Java_CommJavaC_startOffline BEGIN\n");

	for(i = 0; i < size; i++)
	{
		jobject jString = (*env)->GetObjectArrayElement(env, jarray, i);
		sizeString = (*env)->GetStringUTFLength(env, jString);
		const char* cString = (*env)->GetStringUTFChars(env, jString, 0);
		paths[i] = malloc(sizeof(char) * sizeString+1); // vad +1
		strcpy(paths[i], cString);
fprintf(stderr, "Java_CommJavaC_startOffline: %s\n", cString);

	}

	offlineProcessing(paths, size);
fprintf(stderr, "Java_CommJavaC_startOffline END\n");

}
