#include <stdio.h>      /* for printf() and fprintf() */
#include <sys/socket.h> /* for socket(), bind(), and connect() */
#include <arpa/inet.h>  /* for sockaddr_in and inet_ntoa() */
#include <stdlib.h>     /* for atoi() and exit() */
#include <string.h>     /* for memset() */
#include <unistd.h>     /* for close() */

#define MAXPENDING 5    /* Maximum outstanding connection requests */
#define RCVBUFSIZE 10000   /* Size of receive buffer */


void DieWithError(char *errorMessage)  /* Error handling function */
{
    perror(errorMessage);
    exit(1);
}

int msleep(unsigned long milisec)
{
	struct timespec req={0};
	time_t sec=(int)(milisec/1000);
	milisec=milisec-(sec*1000);
	req.tv_sec=sec;
	req.tv_nsec=milisec*1000000L;
	while(nanosleep(&req,&req)==-1)
		continue;
	return 1;
}

int main(int argc, char *argv[])
{
    int servSock;                    /* Socket descriptor for server */
    int clntSock;                    /* Socket descriptor for client */
    struct sockaddr_in echoServAddr; /* Local address */
    struct sockaddr_in echoClntAddr; /* Client address */
    unsigned short echoServPort;     /* Server port */
    unsigned int clntLen;            /* Length of client address data structure */

    char * ips[6] = {"172.16.1.81", "172.16.1.82", "172.16.1.83", "172.16.1.84", "172.16.1.85", "172.16.1.86"};
    int ports[6] = { 25001, 25002, 25003, 25004, 25005, 25006 };

  //  char * ips[2] = {"192.168.114.136", "192.168.114.129"};
  //  int ports[2] = { 25001, 25002 };

    char echoBuffer[RCVBUFSIZE];        /* Buffer for echo string */
    int recvMsgSize;                    /* Size of received message */

    int sock;

    if (argc != 2)     /* Test for correct number of arguments */
    {
        fprintf(stderr, "Usage:  %s <number>(from 0 - 5) \n", argv[0]);
        exit(1);
    }

    int nr = atoi(argv[1]);

    echoServPort = ports[nr];

    if ((servSock = socket(PF_INET, SOCK_STREAM, IPPROTO_TCP)) < 0)
        DieWithError("socket() failed");

    memset(&echoServAddr, 0, sizeof(echoServAddr));   /* Zero out structure */
    echoServAddr.sin_family = AF_INET;                /* Internet address family */
    echoServAddr.sin_addr.s_addr = htonl(INADDR_ANY); /* Any incoming interface */
    echoServAddr.sin_port = htons(echoServPort);      /* Local port */

    if (bind(servSock, (struct sockaddr *) &echoServAddr, sizeof(echoServAddr)) < 0)
        DieWithError("bind() failed");

    if (listen(servSock, MAXPENDING) < 0)
        DieWithError("listen() failed");

    //guy that will start the chain
    if(nr == 0)
    {
    	char msg[10];
    	sprintf(msg, "%d-", nr);
    	int r = nr;
    	struct sockaddr_in echoServAddr;

    	while(r == nr || r >= 6)
    		r = random() % 6;

    	printf("sending toooo %d\n", r);

        if ((sock = socket(PF_INET, SOCK_STREAM, IPPROTO_TCP)) < 0)
            DieWithError("socket() failed");

        /* Construct the server address structure */
        memset(&echoServAddr, 0, sizeof(echoServAddr));     /* Zero out structure */
        echoServAddr.sin_family      = AF_INET;             /* Internet address family */
        echoServAddr.sin_addr.s_addr = inet_addr(ips[r]);   /* Server IP address */
        echoServAddr.sin_port        = htons(ports[r]); /* Server port */

        /* Establish the connection to the echo server */
        if (connect(sock, (struct sockaddr *) &echoServAddr, sizeof(echoServAddr)) < 0)
            DieWithError("connect() failed");

		if (send(sock, msg, strlen(msg), 0) != strlen(msg))
			DieWithError("send() sent a different number of bytes than expected");

		close(sock);
    }

    int counter = 0;

    while(counter < 50)
    {
        clntLen = sizeof(echoClntAddr);

        if ((clntSock = accept(servSock, (struct sockaddr *) &echoClntAddr, &clntLen)) < 0)
            DieWithError("accept() failed");

        memset(echoBuffer, 0, sizeof(echoBuffer));

        if ((recvMsgSize = recv(clntSock, echoBuffer, RCVBUFSIZE, 0)) < 0)
            DieWithError("recv() failed");

        close(clntSock);

        msleep(3000);

    	char msg[10];
    	memset(msg, 0, sizeof(msg));
    	sprintf(msg, "%d-", nr);
    	int r = nr;
    	struct sockaddr_in echoServAddr;

    	strcat(echoBuffer, msg);

    	while(r == nr || r >= 6)
    	{
    		r = random() % 6;
    	}

        if ((sock = socket(PF_INET, SOCK_STREAM, IPPROTO_TCP)) < 0)
            DieWithError("socket() failed");

        /* Construct the server address structure */
        memset(&echoServAddr, 0, sizeof(echoServAddr));     /* Zero out structure */
        echoServAddr.sin_family      = AF_INET;             /* Internet address family */
        echoServAddr.sin_addr.s_addr = inet_addr(ips[r]);   /* Server IP address */
        echoServAddr.sin_port        = htons(ports[r]); /* Server port */

        /* Establish the connection to the echo server */
        if (connect(sock, (struct sockaddr *) &echoServAddr, sizeof(echoServAddr)) < 0)
            DieWithError("connect() failed");

        //printf("sending:%s\n", echoBuffer);

		if (send(sock, echoBuffer, strlen(echoBuffer), 0) != strlen(echoBuffer))
			DieWithError("send() sent a different number of bytes than expected");

		close(sock);
		counter++;
    }
    close(servSock);
}
