#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netinet/if_ether.h>
#ifdef LINUX
#include <netinet/ether.h>
#endif
#include <netinet/ip.h>

#include <pthread.h>
#include <sys/stat.h>
#include <dirent.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <pcap.h>
#include <math.h>

#include <errno.h>
#include <ctype.h>
#include <unistd.h>
#include <sys/types.h>
#include <fcntl.h>

#include <netdb.h>
#include <sys/types.h>
#include <netinet/in.h>

#include <net/if.h>
#include <ifaddrs.h>

#include <netinet/tcp.h>
#include <netinet/udp.h>

#include <time.h>


#include "reportProcessor.h"

#define MAXPACKETS 1000
#define MAXDATAINTERFACE 100

int loadFromFile = 0;

//TODO no final apagar os nodetimes existentes e libertar o espaço por free
nodeTime* head = NULL;
nodeTime* tail = NULL;
int elements = 0;
int counter = 0;

struct timeval hostCapStart;

u_char fileOutputHeader[30];

char* commBuffer[MAXDATAINTERFACE];
int commElements = 0;
pthread_mutex_t lockFile = PTHREAD_MUTEX_INITIALIZER;

//--------GRAPHICAL VARIABLES------------------
int toDrawInt = 0;
extern int dynamicGraphDraw;
struct dynamicGraphStr* dynamicHead = NULL;
struct dynamicGraphStr* dynamicTail = NULL;
int dynamicSize = 0;
int firstPacket;

//--------OFFLINE VARIABLES------------------
int allWithIP = 1; //we assume all will get his own IP, else the value is changed


void dumpInterfaceData()
{
	int i = 0;
	FILE* dump = fopen("/tmp/remoteMonitor/reports/interface_data.dat", "a");

	for(i = 0; i < commElements; i++)
	{
		if(strlen(commBuffer[i]) > 10)
		{
			fwrite(commBuffer[i], sizeof(char), strlen(commBuffer[i]), dump);
			free(commBuffer[i]);
		}
	}
	memset(commBuffer, 0, sizeof(char*) * commElements);
	commElements = 0;
	fflush(dump);
	fclose(dump);
}

//add new element to tail, and return it
void addNewElement(int socket, struct timeval* startTime, struct timeval* rttTime1, struct timeval* rttTime2, struct timeval* tempRemoteTime, in_addr_t ip)
{
	nodeTime* newnode = malloc(sizeof(struct nodeTimeStr));

	newnode->socket = socket;
	memcpy(&newnode->startTime, startTime, sizeof(struct timeval));
	memcpy(&newnode->rttTime1, rttTime1, sizeof(struct timeval));
	memcpy(&newnode->rttTime2, rttTime2, sizeof(struct timeval));
	memcpy(&newnode->tempRemoteTime, tempRemoteTime, sizeof(struct timeval));
	newnode->ip.s_addr = ip;

	//packets
	newnode->headReport = NULL;
	newnode->tailReport = NULL;
	newnode->npackets = 0;
	newnode->offset = 24;
	newnode->dyna_temp_size = 0;

	newnode->next = NULL;

	if(head == NULL)
		head = newnode;
	else
		tail->next = newnode;

	tail = newnode;
	elements++;

	//save in file the structure for posterior processing
	if(loadFromFile == 0)
	{
		FILE* f = fopen("/tmp/remoteMonitor/reports/times.dat", "w+");
		if(f != NULL)
		{
			nodeTime* temp = head;
			while(temp != NULL)
			{
				fwrite(temp, 1, sizeof(struct nodeTimeStr), f);
				temp = temp->next;
			}
			fclose(f);
		}
		else printf("FOPEN FAIL TO OPEN 'TIMES.DAT'\n");
	}

	//------------------------
	if(toDrawInt == 1)
	{
		pthread_mutex_lock(&lockFile);
			if(commElements >= MAXDATAINTERFACE)
				dumpInterfaceData();

			commBuffer[commElements] = malloc(sizeof(char)*90);
			sprintf(commBuffer[commElements], "%s,%s,0,0;", "green", inet_ntoa(newnode->ip));

			commElements++;

		pthread_mutex_unlock(&lockFile);
	}
}

//TODO loads data from file
void loadData()
{
	loadFromFile = 1;
	nodeTime* temp = malloc(sizeof(struct nodeTimeStr));
	FILE* f = fopen("/tmp/remoteMonitor/reports/times.dat", "r");
	while(fread(temp, sizeof(struct nodeTimeStr), 1, f) > 0)
	{
		addNewElement(temp->socket, &temp->startTime, &temp->rttTime1, &temp->rttTime2, &temp->tempRemoteTime, temp->ip.s_addr);
	}
	free(temp);
	fclose(f);

}

long long timeval_diff(struct timeval *difference, struct timeval *end_time, struct timeval *start_time)
{
	struct timeval temp_diff;

	if(difference==NULL)
	{
		difference=&temp_diff;
	}

	difference->tv_sec =end_time->tv_sec -start_time->tv_sec ;
	difference->tv_usec=end_time->tv_usec-start_time->tv_usec;

	/* Using while instead of if below makes the code slightly more robust. */

	while(difference->tv_usec<0)
	{
		difference->tv_usec+=1000000;
		difference->tv_sec -=1;
	}

	return 1000000LL*difference->tv_sec + difference->tv_usec;

}

/*
 * Load packets in memory, at the node buffer;
 * returns 1 if sucess and 0 is there is no more packets to load (all loaded)
 * */

//vai carregar pacotes, mas retira 500 bytes de cada vez do ficheiro, e mete os pacotes, se esses 500bytes em pacotes fizerem com que os pacotes
//ultrapassem o MAXPACKETS, não tem problema
//Mas caso não ultrapassem, vai tirando mais 500 bytes e carrega em ficheiros.
void loadPackets(nodeTime* node){

	int tempOffset = 0;
	int sizeToRead = 500000;
	int sizeAltered = 0;
	u_char* buffer = malloc(sizeof(u_char*) * sizeToRead);  //read from file 10000 bytes each times

	int headerSize = sizeof(struct pcap_pkthdr);
fprintf(stderr,"loadPackets BEGIN\n");
	while(node->npackets < MAXPACKETS)
	{
		fseek(node->report, node->offset, SEEK_SET);  //skip the head of the file

		int readed = fread(buffer, 1, sizeToRead, node->report);
		fprintf(stderr,"loadPackets: fread returns 0 (sizeToRead=%d)\n", sizeToRead);
		tempOffset = 0;
		sizeAltered = 0;
		while(tempOffset + headerSize < readed) //since the header of packet is 16 bytes
		{
			struct pcap_pkthdr* temp = (struct pcap_pkthdr*)(buffer + tempOffset);
			if(tempOffset + headerSize + temp->caplen <= readed) //the data from packet is in memory
			{
				reportData* newNode = malloc(sizeof(struct nodeReportDataStr));
				newNode->packet = malloc(sizeof(u_char) * temp->caplen + sizeof(struct pcap_pkthdr));
				u_char* from = buffer + tempOffset;
				int sz = sizeof(u_char) * temp->caplen + sizeof(struct pcap_pkthdr);
				memcpy(newNode->packet, from, sz);
				newNode->next = NULL;

				//insert in list
				if(node->headReport == NULL)
					node->headReport = newNode;
				else
					node->tailReport->next = newNode;

				node->tailReport = newNode;

				node->npackets++;
				tempOffset += headerSize + temp->caplen;

			}
			else
			{
				//the packet data is not in memory, need to increase the nr of bytes to read
				//sizeToRead = sizeToRead * 1.5;
				free(buffer);
				buffer = malloc(sizeof(u_char*) * sizeToRead);  //read from file 500000 bytes each times

				if(buffer == NULL)
				{
					perror("BUFFER ERROR");
					exit(1);
				}
				sizeAltered = 1;
				break;
			}
		}
		node->offset += tempOffset;

		//if it read less than the 500 bytes asked, its because at this point, all the packets are loaded
		if(readed < sizeToRead && sizeAltered == 0)
		{
			node->tailReport = NULL; //then all packets are load, the tail is put to NULL, so when we ask for more packets, we know that we will not load anymore
			break;
		}
	}
	free(buffer);
fprintf(stderr,"loadPackets END\n");

}

//calculates the delay relatevely to the server
void calculateTimes()
{
	long rtt_s; //rtt seconds part
	long rtt_ms;  //rtt miliseconds part

	char path[200];

	nodeTime* hostOrig = head;
	nodeTime* temp = NULL;
	if(hostOrig != NULL)
	{
		sprintf(path, "/tmp/remoteMonitor/reports/report%d.dat",hostOrig->socket);

		//host
		hostOrig->report = fopen(path, "r");
		hostOrig->diff.tv_sec = 0;
		hostOrig->diff.tv_usec = 0;

		fread(fileOutputHeader, 1, 24, hostOrig->report); //load the header of the file, needed for the file be in pcap form
		fclose(hostOrig->report);

		temp = hostOrig;
	}

	while(temp != NULL)
	{
		rtt_s = temp->rttTime2.tv_sec - temp->rttTime1.tv_sec;
		rtt_ms = temp->rttTime2.tv_usec - temp->rttTime1.tv_usec;

		//struct timeval result;
		struct timeval temptime;
		temptime.tv_sec = temp->tempRemoteTime.tv_sec + (rtt_s / 2);
		temptime.tv_usec = temp->tempRemoteTime.tv_usec + (rtt_ms / 2);

		timeval_diff(&temp->diff, &temp->rttTime2, &temptime); //result, time when readed rtt2, time readed in remote plus half of the rtt to be at same possible time

		printf( "Diferença -> %ld.%.6ld\n", temp->diff.tv_sec, temp->diff.tv_usec);

		//------------------------------------------load report file----------------------------------------
		memset(&path, 0, sizeof(path));
		sprintf(path, "/tmp/remoteMonitor/reports/report%d.dat",temp->socket);
		temp->report = fopen(path, "r");
		//-------------------------------------load packets to memory---------------------------------------------
		loadPackets(temp);
		temp = temp->next;  //next report
	}
}

/*
 * Will try to find the packet brother, so it can be deleted, and reduce the packet processing
 * */
//void checkIfPacketExists(reportData* pack, char* owner_ip)
void checkIfPacketExists(reportData* pack, in_addr_t owner_ip)
{
	struct ip* pack_ipc;

	in_addr_t look_at;
	in_addr_t pack_src_ip;
	in_addr_t pack_dst_ip;

	uint16_t pack_id;

	pack_ipc = (struct ip*)(pack->packet + sizeof(struct ether_header) + sizeof(struct pcap_pkthdr));
	pack_id = ntohs(pack_ipc->ip_id);

	pack_src_ip = pack_ipc->ip_src.s_addr;
	pack_dst_ip = pack_ipc->ip_dst.s_addr;

	if(pack_dst_ip == owner_ip)
		look_at = pack_src_ip;
	else look_at = pack_dst_ip;

	nodeTime* nodeTarget = head;
	reportData* temp;
	reportData* temp_prev;
	struct ip* temp_ipc;
	in_addr_t temp_src_ip;
	in_addr_t temp_dst_ip;

	//if all the nodes have the own ip, we just find the node with the second ip found in the packet
	// because he can have the copy of the packet, that don't need to be processed again.
	//if allWithIP == 0, we don't know the ip of all nodes, so we search for the packet copy in all nodes
	if(allWithIP == 1)
	{
		while(nodeTarget != NULL)
		{
			if(nodeTarget->ip.s_addr == look_at)
				break;
			nodeTarget = nodeTarget->next;
		}

		if(nodeTarget != NULL)
		{
			//will search inside all packets loaded at target node
			temp = nodeTarget->headReport;
			temp_prev = NULL;
			while(temp != NULL)
			{
				temp_ipc = (struct ip*)(temp->packet + sizeof(struct ether_header) + sizeof(struct pcap_pkthdr));
				temp_src_ip = temp_ipc->ip_src.s_addr;
				temp_dst_ip = temp_ipc->ip_dst.s_addr;

				if(temp_src_ip == pack_src_ip && temp_dst_ip == pack_dst_ip && pack_id == ntohs(temp_ipc->ip_id))
				{
					//FOUND
					if(temp_prev == NULL) //first packet in list
					{
						nodeTarget->headReport = temp->next;
					}
					else
					if(temp->next == NULL)  //last packt in list
					{
						if(nodeTarget->tailReport != NULL)
							nodeTarget->tailReport = temp_prev;
					}
					else
					{
						temp_prev->next = temp->next;
					}

					free(temp->packet);
					free(temp);
					nodeTarget->npackets--;

					//check if needed to load more packets
					if(nodeTarget->tailReport != NULL && nodeTarget->npackets <= MAXPACKETS/2)
						loadPackets(nodeTarget);

					break;
				}

				temp_prev = temp;
				temp = temp->next;
			}
		}
	}
	else
	{
		//going to search in all node except the one that
		while(nodeTarget != NULL)
		{

			//TODO verifica o ip e o ip2 e só quem tiver um dos ips que que se quer é e se pesquisa
			if(nodeTarget->ip.s_addr == pack_src_ip || nodeTarget->ip.s_addr == pack_dst_ip ||
			   nodeTarget->ip2.s_addr == pack_src_ip || nodeTarget->ip2.s_addr == pack_dst_ip)
			temp = nodeTarget->headReport;
			temp_prev = NULL;
			while(temp != NULL)
			{
				temp_ipc = (struct ip*)(temp->packet + sizeof(struct ether_header) + sizeof(struct pcap_pkthdr));

				temp_src_ip = temp_ipc->ip_src.s_addr;
				temp_dst_ip = temp_ipc->ip_dst.s_addr;

				if(temp_src_ip == pack_src_ip && temp_dst_ip == pack_dst_ip && pack_id == ntohs(temp_ipc->ip_id))
				{
					//FOUND
					if(temp_prev == NULL) //first packet in list
					{
						nodeTarget->headReport = temp->next;
					}
					else
					if(temp->next == NULL)  //last packt in list
					{
						if(nodeTarget->tailReport != NULL)
							nodeTarget->tailReport = temp_prev;
					}
					else
					{
						temp_prev->next = temp->next;
					}

					free(temp->packet);
					free(temp);
					nodeTarget->npackets--;

					//check if needed to load more packets
					if(nodeTarget->tailReport != NULL && nodeTarget->npackets <= MAXPACKETS/2)
						loadPackets(nodeTarget);

					break;
				}

				temp_prev = temp;
				temp = temp->next;
			}

			nodeTarget = nodeTarget->next;
		}

	}
}

//creates a unique log with all the packets (without filtering) and all ordered
void insertOrderedPackets()
{
	FILE* output = fopen("/tmp/remoteMonitor/reports/ordered.dat", "w+");
//vad
	perror("/tmp/remoteMonitor/reports/ordered.dat");
	fwrite(fileOutputHeader, 1, 24, output);

	struct timeval toCompare;

	reportData* toInsert = NULL;
	reportData* temp = NULL;
	nodeTime* currNode;
	nodeTime* toInsert_Node;

	struct pcap_pkthdr* toInsertHeader;

	while(1)
	{
		currNode = head;
fprintf(stderr,"insertOrderedPackets loop\n");
		while(currNode != NULL)
		{
			if(currNode->headReport != NULL)
			{
				temp = currNode->headReport;

				if(toInsert == NULL)
				{
					toInsert = temp;
					toInsert_Node = currNode;

					toInsertHeader = (struct pcap_pkthdr*)toInsert->packet;
				}
				else
				{
					struct pcap_pkthdr* header = (struct pcap_pkthdr*)temp->packet;
					toCompare.tv_sec = header->ts.tv_sec + currNode->diff.tv_sec;
					toCompare.tv_usec = header->ts.tv_usec + currNode->diff.tv_usec;

					if(toCompare.tv_usec > 1000000)
					{
						toCompare.tv_sec++;
						toCompare.tv_usec -= 1000000;
					}

					if((toInsertHeader->ts.tv_sec > toCompare.tv_sec) ||
					   (toInsertHeader->ts.tv_sec == toCompare.tv_sec && toInsertHeader->ts.tv_usec > toCompare.tv_usec) )
					{
						//this one is the next candidate to insert
						toInsert = temp;
						toInsert_Node = currNode;

						toInsertHeader = (struct pcap_pkthdr*)toInsert->packet;
					}
				}
			}

			currNode = currNode->next;
		}

		if(toInsert != NULL)
		{
			//remove the element from list
			toInsert_Node->headReport = toInsert->next;
			toInsert_Node->npackets--;

			checkIfPacketExists(toInsert, toInsert_Node->ip.s_addr); //check if is in any report log, the same packet

			//write to file
			int sizeToWrite = toInsertHeader->caplen + sizeof(struct pcap_pkthdr);
			fwrite(toInsert->packet, 1, sizeToWrite, output);
			fflush(output);

			if(toInsert_Node->tailReport != NULL && toInsert_Node->npackets < (MAXPACKETS / 2))
			{
				loadPackets(toInsert_Node);
			}
			//---------insert connection to draw in graph -----------
			if(toDrawInt == 1 && dynamicGraphDraw == 0 && toInsertHeader->len > 0 && toInsertHeader->ts.tv_sec > 0) //if is to draw the graphic, but only when capture finished
			{
				pthread_mutex_lock(&lockFile);
					if(commElements >= MAXDATAINTERFACE)
						dumpInterfaceData();

					commBuffer[commElements] = malloc(sizeof(char)*90);
					struct ip* temp_ipc = (struct ip*)(toInsert->packet + sizeof(struct ether_header) + sizeof(struct pcap_pkthdr));
					char temp_src_ip[30];
					strcpy(temp_src_ip, inet_ntoa(temp_ipc->ip_src)); //since inet_ntoa do buffering with the char* that returns from it
					sprintf(commBuffer[commElements], "%s,%s,%u,%ld;", temp_src_ip, inet_ntoa(temp_ipc->ip_dst), toInsertHeader->len, toInsertHeader->ts.tv_sec);
					commElements++;
				pthread_mutex_unlock(&lockFile);
			}
			//---------------------------------

			free(toInsert->packet);
			free(toInsert);

			toInsert = NULL;
			toInsertHeader = NULL;
		}
		else
		{
			//all packets inserted
			fflush(output);
			fclose(output);
			dumpInterfaceData();
			break;
		}
	}
}

void setInterfaceInteraction()
{
	toDrawInt = 1;
	printf("toDrawInterface = %d\n", toDrawInt);
}

void newGraphTrace(u_char* buf, int size, int fp)
{
	firstPacket = fp;
	dynamicGraph* dyna = malloc(sizeof(struct dynamicGraphStr));

	dyna->size = size;
	dyna->buffer = malloc(sizeof(u_char*) * size);
	memcpy(dyna->buffer, buf, dyna->size);
	dyna->next = NULL;

	if(dynamicHead == NULL)
		dynamicHead = dyna;

	if(dynamicTail != NULL)
		dynamicTail->next = dyna;

	dynamicTail = dyna;
	dynamicSize += dyna->size;
}

void processGraphTrace(int socketfd)
{
printf("processing trace\n");
	u_char* buffer;
	int offset = 0;

	dynamicGraph* temp = dynamicHead;
	dynamicGraph* toDestroy = temp;
	u_char* tempPointer;

	struct ip* ipc;
	struct pcap_pkthdr* tempHeader;
	int buffRemains = 0;

	nodeTime* node = head;
	/*search for the respective node, and check if there is remains from previous reception*/
	while(node != NULL)
	{
		if(node->socket == socketfd)
		{
			buffer = malloc( sizeof(u_char*) * (dynamicSize + node->dyna_temp_size) ); //create one buffer large enough to store all the report received plus remains
			if(node->dyna_temp_size > 0)
			{
				memcpy(buffer, node->dyna_temp_buf, node->dyna_temp_size);
				free(node->dyna_temp_buf);
				node->dyna_temp_size = 0;
			}
			break;
		}
		node = node->next;
	}

	//load all packets into buffer so all be together, in continuos memory zone
	while(temp != NULL)
	{
		tempPointer = buffer + offset;
		memcpy(tempPointer, temp->buffer, temp->size);
		offset += temp->size;
		toDestroy = temp;
		temp = temp->next;
		free(toDestroy->buffer);
		free(toDestroy);
	}

	//process buffer, reading the buffer and putting the relevation information in the commBuffer
	if(firstPacket == 1)
		offset = 24;
	else offset = 0;

	pthread_mutex_lock(&lockFile);
		while(offset < dynamicSize)
		{
			if(commElements >= MAXDATAINTERFACE)
				dumpInterfaceData();

			//first test if the header is in this block of memory, or is in route to be received
			if(offset + sizeof(struct pcap_pkthdr) < dynamicSize)
			{
				tempHeader = (struct pcap_pkthdr*)(buffer + offset);
				if(offset + sizeof(struct pcap_pkthdr) + tempHeader->caplen <= dynamicSize && tempHeader->len > 0 && tempHeader->ts.tv_sec > 0)
				{
					ipc = (struct ip*)(buffer + offset + sizeof(struct ether_header) + sizeof(struct pcap_pkthdr));
					commBuffer[commElements] = malloc(sizeof(char)*90);
					char temp_src_ip[30];
					strcpy(temp_src_ip, inet_ntoa(ipc->ip_src)); //since inet_ntoa do buffering with the char* that returns from it
					sprintf(commBuffer[commElements], "%s,%s,%u,%ld;", temp_src_ip, inet_ntoa(ipc->ip_dst), tempHeader->len, tempHeader->ts.tv_sec);
					commElements++;
					offset += sizeof(struct pcap_pkthdr) + tempHeader->caplen;
				}
				else buffRemains = 1;
			}
			else buffRemains = 1;

			if(buffRemains == 1)
			{
				node->dyna_temp_size = dynamicSize - offset;
			if(node->dyna_temp_size > 0)
			{
				node->dyna_temp_buf = malloc(sizeof(u_char) * node->dyna_temp_size);
				memcpy(node->dyna_temp_buf, (u_char*)(buffer + offset), node->dyna_temp_size);
			}
				break;
			}

		}

		dumpInterfaceData(); //dump all the stored info so it can be load quicker in interface

	pthread_mutex_unlock(&lockFile);
	dynamicHead = NULL;
	dynamicTail = NULL;
	dynamicSize = 0;

	free(buffer);
}

//----------------------------------- OFFLINE FUNCTIONS -------------------------



/*
 * socket -> will be the counter for files (file 1 -> socket 1, file 2 -> socket 2, ...)
 *
 */
void addNewOfflineElement(int socket, char* filepath)
{
	nodeTime* newnode = malloc(sizeof(struct nodeTimeStr));

	newnode->socket = socket;

fprintf(stderr,"addNewOfflineElement BEGIN socket=%d, filepath=%s\n", socket, filepath);
	//packets
	newnode->headReport = NULL;
	newnode->tailReport = NULL;
	newnode->npackets = 0;
	newnode->offset = 24;
	newnode->next = NULL;
	newnode->diff.tv_sec = 0;
	newnode->diff.tv_usec = 0;
	//------------------------
	newnode->report = fopen(filepath, "r"); //opens the file indicated;

	if(newnode->report != NULL)
	{
		// load the packets from file to the buffer
		loadPackets(newnode);

		//from the packets in memory trys to find the IP Address in use by the computer that produces this report
		reportData* temp;
		struct ip* temp_ipc;
		in_addr_t first_src_ip;
		in_addr_t first_dst_ip;
		in_addr_t temp_src_ip;
		in_addr_t temp_dst_ip;
		int found = 0;

		//will search inside all packets loaded at target node
		temp = newnode->headReport;
		if(temp != NULL)
		{
			temp_ipc = (struct ip*)(temp->packet + sizeof(struct ether_header) + sizeof(struct pcap_pkthdr));
			first_src_ip = temp_ipc->ip_src.s_addr;
			first_dst_ip = temp_ipc->ip_dst.s_addr;
			temp = temp->next;
		}

		//check the others packets trying to determinate the IP
		while(temp != NULL)
		{
			temp_ipc = (struct ip*)(temp->packet + sizeof(struct ether_header) + sizeof(struct pcap_pkthdr));
			temp_src_ip = temp_ipc->ip_src.s_addr;
			temp_dst_ip = temp_ipc->ip_dst.s_addr;

			if(first_src_ip == temp_src_ip && first_dst_ip != temp_dst_ip)
			{
				newnode->ip.s_addr = first_src_ip;
				found = 1;
				break;
			}
			else
			if(first_src_ip == temp_dst_ip && first_dst_ip != temp_src_ip)
			{
				newnode->ip.s_addr = first_src_ip;
				found = 1;
				break;
			}
			else
			if(first_dst_ip == temp_src_ip && first_src_ip != temp_dst_ip)
			{
				newnode->ip.s_addr = first_dst_ip;
				found = 1;
				break;
			}
			else
			if(first_dst_ip == temp_dst_ip && first_src_ip != temp_src_ip)
			{
				newnode->ip.s_addr = first_dst_ip;
				found = 1;
				break;
			}

			temp = temp->next;
		}

		//IP not found or other report file cannot determinate IP, so all will have 2 IPs
		if(found == 0 || allWithIP == 0)
		{
			allWithIP = 0;
			printf("CANNOT DETERMINATE IP FROM %d\n", socket);
			newnode->ip.s_addr = first_src_ip;
			newnode->ip2.s_addr = first_dst_ip;
		}
		else
		printf("IP->%d----->%s\n", socket, inet_ntoa(newnode->ip));

		// put the node in list
		if(head == NULL)
			head = newnode;
		else
			tail->next = newnode;

		tail = newnode;
		elements++;

	//-----------DRAW INFO-------------
		if(toDrawInt == 1 && found == 1)
		{
			pthread_mutex_lock(&lockFile);
fprintf(stderr, "addNewOfflineElement lock\n");
				if(commElements >= MAXDATAINTERFACE)
					dumpInterfaceData();

				commBuffer[commElements] = malloc(sizeof(char)*90);
				sprintf(commBuffer[commElements], "%s,%s,0,0;", "green", inet_ntoa(newnode->ip));

				commElements++;

			pthread_mutex_unlock(&lockFile);
fprintf(stderr, "addNewOfflineElement unlock\n");
		}
	}
	else { 
		perror(filepath);
		free(newnode);
	}
fprintf(stderr,"addNewOfflineElement END\n");
}

void offlineProcessing(char** paths, int size)
{
	setInterfaceInteraction();

	// create the destination folders
	mkdir("/tmp/remoteMonitor",0777);
	mkdir("/tmp/remoteMonitor/reports",0777);
	mkdir("/tmp/remoteMonitor/filter",0777);

	FILE* dump = fopen("/tmp/remoteMonitor/reports/interface_data.dat", "w+");
	if(dump != NULL)
	{
		fclose(dump);
		remove("/tmp/remoteMonitor/reports/interface_data.dat");
	}
	else fclose(dump);

	int i = 0;
	for(i = 0; i < size; i++)
	{
		printf("PATH %d -> %s\n", i, *(paths + i));
		addNewOfflineElement(i, paths[i]);
	}

fprintf(stderr,"offlineProcessing going to insertOrderedPackets\n");
	insertOrderedPackets();
fprintf(stderr,"offlineProcessing END\n");
}




