#include <time.h>
#include <pcap.h>
#include <netinet/in.h>

#ifndef REPORTPROCESSOR_H_
#define REPORTPROCESSOR_H_

//estrutura para cada um dos pacotes.
typedef struct nodeReportDataStr{

	struct pcap_pkthdr header;
	u_char* packet;

	struct nodeReportDataStr* next;

}reportData;

typedef struct nodeTimeStr{
	int socket; //socket that is connected form host to the other computer, receiving the temporary reports
	//char ip[30];
	struct in_addr ip;
	struct in_addr ip2; /*This IP is used for offline operation*/

	struct timeval startTime;  //remote Time when started the capture

	//needed to calculate the rtt and to calculate the diference time between them
	struct timeval rttTime1;  //Round Trip Time1
	struct timeval rttTime2;  //Round Trip Time2 -> used to calculate the diference between the clocks

	//needed to calculate the diference time between them
	struct timeval tempRemoteTime;   //remote timer when was asked for his current time

	int reference; //if is the main clock (reference)

	//filled when starting analizing packets
	struct timeval diff;
	FILE* report; //pointer for the report file

	//TODO apontadores para os arrays que vão conter pacotes recebidos e enviados.

	struct nodeReportDataStr* headReport;  //head packet
	struct nodeReportDataStr* tailReport; //last packet
	int npackets;
	int offset; //the position where will read from file.

	u_char* dyna_temp_buf;
	int dyna_temp_size;

	struct nodeTimeStr* next;

}nodeTime;


//TODO possivel integração com a estrutura descrita em cima
typedef struct dynamicGraphStr{

	u_char* buffer;
	int size;
	struct dynamicGraphStr* next;

}dynamicGraph;


void addNewElement(int socket, struct timeval* startTime, struct timeval* rttTime1, struct timeval* rttTime2, struct timeval* tempRemoteTime, in_addr_t ip);

void loadData();

void calculateTimes();

void insertOrderedPackets();

void newGraphTrace(u_char* buf, int size, int fp);

void processGraphTrace(int socketfd);

void offlineProcessing(char** paths, int size);

//---------------FOR JAVA--------------

void setInterfaceInteraction();

#endif /* REPORTPROCESSOR_H_ */
