

import java.io.*;
import java.util.*;

public class CommJavaC
{

    private native void startRunning(int pid, int port, int remote, int dynamic, String filter);
    private native void stopRunning();
    private native void lockFileToRead();
    private native void unlockFileToRead();
    private native void startOffline(String[] files);

    private class hashElement{
        public String ip1;
        public String ip2;
        public int len = 0;
        public long timeStart = 0;
        public long lastTime = 0;


        @Override
        public boolean equals(Object obj) {
            if (obj == null) {
                return false;
            }
            if (getClass() != obj.getClass()) {
                return false;
            }
            final hashElement other = (hashElement) obj;
            if ((this.ip1 == null) ? (other.ip1 != null) : !this.ip1.equals(other.ip1)) {
                return false;
            }
            if ((this.ip2 == null) ? (other.ip2 != null) : !this.ip2.equals(other.ip2)) {
                return false;
            }
            return true;
        }

        @Override
        public int hashCode() {
            int hash = 7;
            hash = 79 * hash + (this.ip1 != null ? this.ip1.hashCode() : 0);
            hash = 79 * hash + (this.ip2 != null ? this.ip2.hashCode() : 0);
            return hash;
        }
    }
    
    //private boolean offlineMode;
    private HashMap<hashElement, hashElement> actions;
    private final Vector<String> news;
    private long offset;

    static
    {
        String curDir = System.getProperty("user.dir");
        System.load(curDir + "/commJava.so");
      //System.load("/home/arknot/Desktop/captura/src/commJava.so");
    }

    public CommJavaC()
    {
        actions = new HashMap<hashElement, hashElement>();
        news = new Vector<String>();
        offset = 0;
       // offlineMode = false;
    }

    public void startMonitoring(int pid, int port, int remote, int dynamic, String filter)
    {
        startRunning(pid, port, remote, dynamic, filter);
    }

    public String stopMonitoring()
    {
        stopRunning();

        String result = "/tmp/remoteMonitor/reports/ordered.dat";
        return result;
    }

    public void addNew(String s1)
    {
        String ip1;
        String ip2;
        String len;
        String epoch;

        Scanner scan = new Scanner(s1);
        scan.useDelimiter(",");
        ip1 = scan.next();
        ip2 = scan.next();
        len = scan.next();
        epoch = scan.next();        

        if(ip1.compareTo("green") == 0) //inserted by receiving the report
        {
            hashElement he = new hashElement();
            he.ip1 = ip2;
            he.ip2 = ip2;

            if(actions.containsKey(he)) //if already in and we want to put green
            {
                String toInsert = "change;" + ip2 + ";0";
                synchronized(news){
                    news.add(toInsert);
                }
            }
            else
            {
                synchronized(news){
                    actions.put(he, he);
                    String s = "green" + ";" + ip2 + ";0";
                    news.add(s);
                }
            }
        }
        else //s1 and s2 are IPs
        {
            hashElement he1 = new hashElement();
            he1.ip1 = ip1;
            he1.ip2 = ip1;

            if(!actions.containsKey(he1)) //not found first element
            {
                String toInsert = "red;" + ip1 + ";0";
                synchronized(news){
                    actions.put(he1, he1);
                    news.add(toInsert);
                }
            }

            hashElement he2 = new hashElement();
            he2.ip1 = ip2;
            he2.ip2 = ip2;

            if(!actions.containsKey(he2))
            {
                String toInsert = "red;" + ip2 + ";0";
                synchronized(news){
                    actions.put(he2, he2);
                    news.add(toInsert);
                }
            }

            hashElement heArc = new hashElement();
            if(ip1.compareTo(ip2) < 0)
            {
                heArc.ip1 = ip1;
                heArc.ip2 = ip2;
            }
            else
            {
                heArc.ip1 = ip2;
                heArc.ip2 = ip1;
            }
            
            hashElement heFound = actions.get(heArc);

            if(heFound == null)
            {
                synchronized(news){

                    //heArc.lastTime = Integer.parseInt(epoch);
                    //heArc.timeStart = Integer.parseInt(epoch);
                    heArc.lastTime = System.currentTimeMillis();
                    heArc.timeStart = System.currentTimeMillis();
                    heArc.len = Integer.parseInt(len);

       //             String rs = ip1 + ";" + ip2 + ";0";
                    actions.put(heArc, heArc);

         //           news.add(rs);
                }
            }
            else
            {
                //arc already in, updating values
                synchronized(news){
                  //  if(heFound.timeStart <= 10)
                   //     heFound.timeStart = Integer.parseInt(epoch);

                    //heFound.lastTime = Integer.parseInt(epoch);

                    if(heFound.timeStart <= 10)
                        heFound.timeStart = System.currentTimeMillis();

                    heFound.lastTime = System.currentTimeMillis();
                    heFound.len = heFound.len + Integer.parseInt(len);
                }
            }
        }
    }

    /*
     * Try to lock the file, in C code, read from offset to end of file, unlock the file and update the offset
     *
     * after unlock, start processing the info that readed
     *
     */
    public void getNewMembers()
    {
         File f = new File("/tmp/remoteMonitor/reports/interface_data.dat");
       //  File f = new File("/home/arknot/Desktop/interface_data.dat");
         if(f.exists())
         {
             lockFileToRead();
             
             try{
                RandomAccessFile randfile = new RandomAccessFile(f, "r");
                long length = randfile.length();
                if((int)offset < (int)length)
                {
                    randfile.seek(offset);

                    byte[] buf = new byte[(int)(length - offset)];

                    int ret = randfile.read(buf, 0, (int)(length - offset));

                    //readed something if != -1
                    if(ret != -1)
                    {
                        offset += ret;
                        //ByteArrayInputStream bais = new ByteArrayInputStream(buf);

                        String str = new String(buf);
                        Scanner scan = new Scanner(str);
                        scan.useDelimiter(";");
                        while(scan.hasNext())
                            addNew(scan.next());
                    }
                }
                randfile.close();
                unlockFileToRead();

            }catch (Exception e){
               // System.err.println("Error =D: " + e.getMessage());
               // e.printStackTrace();
            }
         }
    }

    public Vector<String> getNews()
    {
        getNewMembers();

      //  if(news.size() > 0)
        {
            Vector<String> temp;
            synchronized(news)
            {
                temp = (Vector<String>)news.clone();
                news.clear();

                Collection<hashElement> set = actions.values();
                Iterator<hashElement> i = set.iterator();
                while(i.hasNext())
                {
                    hashElement he = i.next();
                    if(he.ip1.compareTo(he.ip2) != 0)
                    {
                        String toadd = "";
                        long diftime = (he.lastTime - he.timeStart) / 1000;
                        if(diftime > 0)
                        {
                            int bytepersecond = (int)(he.len / diftime);
                            toadd = he.ip1 + ";" + he.ip2 + ";" + bytepersecond;
                            temp.add(toadd);
                        }
                        else 
                        {
                            toadd = he.ip1 + ";" + he.ip2 + ";" + he.len;
                            temp.add(toadd);
                        }
                    }
                }
            }

            return temp;
        }
      //  else
        //    return null;
    }

    public void loadFiles(Vector<String> files)
    {
        //offlineMode = true;
        String fs[] = new String[files.size()];

        for(int i = 0; i < files.size(); i++)
        {
            fs[i] = files.get(i);
        }
        
        startOffline(fs);        
    }

}

