

import java.awt.Color;
import java.awt.Dimension;

import java.awt.geom.Rectangle2D;
import java.util.*;

import javax.swing.JApplet;
import javax.swing.JPanel;

import org.jgraph.JGraph;
import org.jgraph.graph.AttributeMap;
import org.jgraph.graph.DefaultGraphCell;
import org.jgraph.graph.GraphConstants;

import org.jgrapht.ListenableGraph;
import org.jgrapht.ext.JGraphModelAdapter;
import org.jgrapht.graph.DefaultEdge;
import org.jgrapht.graph.ListenableUndirectedGraph;

public class GraphEngine extends JPanel {
    private static final Color     DEFAULT_BG_COLOR = Color.decode( "#FAFBFF" );
    private static final Color     DEFAULT_VERTEX_COLOR = Color.LIGHT_GRAY;
    private static final Color     DEFAULT_EDGE_COLOR = Color.BLACK;
    private static final int       DEFAULT_LINE_WIDTH = 1;
    private static final Color     SELECTED_VERTEX_COLOR = Color.BLUE;
    private static final Color     SELECTED_EDGE_COLOR = Color.RED;
    private static final int       SELECTED_LINE_WIDTH = 3;

    private static Dimension DEFAULT_SIZE;

    private JGraphModelAdapter jgraphmodel;
    public JGraph jgraph;
    private ListenableGraph lgraph;

    private boolean coloring;
    Object cellToColor;
    Color prevColorCell;

    //TODO-..
    Random rand = new Random();
    //int width;
    //int height;
    //TODO

    public GraphEngine(int width, int height)
    {
        DEFAULT_SIZE = new Dimension( width, height );

        //this.width = width;
        //this.height = height;
    }

    //@Override 
    public void init() {
        // create a JGraphT graph
        //ListenableGraph g = new ListenableDirectedGraph( DefaultEdge.class );
        lgraph = new ListenableUndirectedGraph( DefaultEdge.class );

        // create a visualization using JGraph, via an adapter
        jgraphmodel = new JGraphModelAdapter( lgraph );
        jgraph = new JGraph( jgraphmodel );
        
        jgraph.setBackground(DEFAULT_BG_COLOR);
	this.add(jgraph);
       // resize( DEFAULT_SIZE );
        //getContentPane(  ).add( jgraph );
        //---------------settings from Vertex--------------
        AttributeMap mp = jgraphmodel.getDefaultVertexAttributes();
        GraphConstants.setSelectable(mp, true);
        GraphConstants.setSizeable(mp, false);
        GraphConstants.setEditable(mp, false);
        GraphConstants.setBackground(mp, DEFAULT_VERTEX_COLOR);

        Rectangle2D b    = (Rectangle2D) GraphConstants.getBounds( mp );
        GraphConstants.setBounds( mp, new Rectangle2D.Double(50, 50, b.getWidth()+20, b.getHeight()) );

        jgraphmodel.setDefaultVertexAttributes(mp);
        //-------------------------------------------------
        //---------------settings from Edges--------------
        jgraph.setEdgeLabelsMovable(false);
        mp = jgraphmodel.getDefaultEdgeAttributes();
        GraphConstants.setSelectable(mp, false);
        GraphConstants.setEditable(mp, false);
        GraphConstants.setLineColor(mp, DEFAULT_EDGE_COLOR);
        GraphConstants.setLabelEnabled(mp, true);
        GraphConstants.setForeground(mp, Color.RED);
     //   GraphConstants.setLabelAlongEdge(mp, true);
        GraphConstants.setOpaque(mp, true);

        jgraphmodel.setDefaultEdgeAttributes(mp);
        //-------------------------------------------------

        coloring = false;
        cellToColor = null;

        jgraph.addMouseListener(new java.awt.event.MouseAdapter() {
            @Override public void mouseClicked(java.awt.event.MouseEvent evt) {
                if(coloring)
                {
                    Object cell = jgraph.getSelectionCellAt(evt.getPoint());
                    if(cell != null)
                    {
                        if(!cell.equals(cellToColor))
                            vertexSelected(cell, SELECTED_VERTEX_COLOR, SELECTED_EDGE_COLOR);
                    }
                }
            }
        });
	
	jgraph.repaint();
	
    }

    public void Coloring(boolean selected) {
        if(coloring == true && selected == false) //is something is colored and now is to stop color
            vertexSelected(null, null, null);
        else
        if(cellToColor != null && selected == true) //cellToColor was colored in the pass
            vertexSelected(cellToColor, SELECTED_VERTEX_COLOR, SELECTED_EDGE_COLOR);

        coloring = selected;
    }

    public void clearAll() {
        //jgraph;
        //getContentPane(  ).add( jgraph );
        System.out.println("GOING TO CLEAR ALL NODES");
        jgraph.removeAll();
        
	this.remove(jgraph);
        //getContentPane().remove(jgraph);

        init();
        //jgraph.removeAll();
        
      //  lgraph = new ListenableUndirectedGraph( DefaultEdge.class );
       // jgraphmodel = new JGraphModelAdapter( lgraph );
      //  jgraph = new JGraph( jgraphmodel );
      //  getContentPane().add(jgraph);
        System.out.println("NEW GRAPH");
    }

    private void positionVertexAt( Object vertex, int x, int y ) {
        DefaultGraphCell cell = jgraphmodel.getVertexCell( vertex );
    
        Map attr = cell.getAttributes(  );
        Rectangle2D b    = (Rectangle2D) GraphConstants.getBounds( attr );
        GraphConstants.setBounds( attr, new Rectangle2D.Double(x, y, b.getWidth(), b.getHeight()) );

        Map cellAttr = new HashMap(  );
        cellAttr.put( cell, cellAttr );

        jgraphmodel.edit(cellAttr, null, null, null);     
    }

    public void vertexSelected(Object object, Color Vertexcolor, Color Edgecolor){
        Map cellAttr = new HashMap(  );
        
        if(cellToColor != null)  //replaces the color of the cell for the default
        {
           DefaultGraphCell cell = (DefaultGraphCell)cellToColor;
           Map attr = cell.getAttributes();

           GraphConstants.setBackground(attr, prevColorCell); //change vertex color
           GraphConstants.setGradientColor(attr, Color.BLACK);

           Object[] s = JGraphModelAdapter.getEdges(jgraphmodel, cell, true); //incoming edges to cell vertex

           for(int j = 0; j  < s.length; j++)
           {
               org.jgraph.graph.DefaultEdge de = (org.jgraph.graph.DefaultEdge) s[j];
               Map edgemap = de.getAttributes();
               GraphConstants.setLineColor(edgemap, DEFAULT_EDGE_COLOR);
               GraphConstants.setLineWidth(edgemap, DEFAULT_LINE_WIDTH);
               GraphConstants.setForeground(edgemap, Color.RED);
               //GraphConstants.setLineStyle(edgemap, GraphConstants.STYLE_BEZIER);
               cellAttr.put( de, cellAttr );
           }

           s = JGraphModelAdapter.getEdges(jgraphmodel, cell, false); //outcoming edges to cell vertex
           for(int j = 0; j  < s.length; j++)
           {
               org.jgraph.graph.DefaultEdge de = (org.jgraph.graph.DefaultEdge) s[j];
               Map edgemap = de.getAttributes();
               GraphConstants.setLineColor(edgemap, DEFAULT_EDGE_COLOR);
               GraphConstants.setLineWidth(edgemap, DEFAULT_LINE_WIDTH);
               GraphConstants.setForeground(edgemap, Color.RED);
              // GraphConstants.setLineStyle(edgemap, GraphConstants.STYLE_BEZIER);
               cellAttr.put( de, cellAttr );
           }


           cellAttr.put( cell, cellAttr );
           jgraphmodel.edit(cellAttr, null, null, null);
        }

       if(object != null)
       {
           DefaultGraphCell cell = (DefaultGraphCell)object;
           Map attr = cell.getAttributes();           

           prevColorCell = GraphConstants.getBackground(attr);

           GraphConstants.setBackground(attr, Vertexcolor); //change vertex color
           GraphConstants.setGradientColor(attr, Color.BLACK);

           Object[] s = JGraphModelAdapter.getEdges(jgraphmodel, cell, true); //incoming edges to cell vertex

           for(int j = 0; j  < s.length; j++)
           {
               org.jgraph.graph.DefaultEdge de = (org.jgraph.graph.DefaultEdge) s[j];
               Map edgemap = de.getAttributes();
               GraphConstants.setLineColor(edgemap, Edgecolor);
               GraphConstants.setLineWidth(edgemap, SELECTED_LINE_WIDTH);
               GraphConstants.setForeground(edgemap, Color.BLUE);
              // GraphConstants.setLineStyle(edgemap, GraphConstants.STYLE_BEZIER);
               cellAttr.put( de, cellAttr );
           }

           s = JGraphModelAdapter.getEdges(jgraphmodel, cell, false); //outcoming edges to cell vertex
           for(int j = 0; j  < s.length; j++)
           {
               org.jgraph.graph.DefaultEdge de = (org.jgraph.graph.DefaultEdge) s[j];
               Map edgemap = de.getAttributes();
               GraphConstants.setLineColor(edgemap, Edgecolor);
               GraphConstants.setLineWidth(edgemap, SELECTED_LINE_WIDTH);
               GraphConstants.setForeground(edgemap, Color.BLUE);
              // GraphConstants.setLineStyle(edgemap, GraphConstants.STYLE_BEZIER);
               cellAttr.put( de, cellAttr );
           }


           cellAttr.put( cell, cellAttr );
           jgraphmodel.edit(cellAttr, null, null, null);

           
           cellToColor = object;
      }
    }


    public void InsertVertex(String value, Color color)
    {
        //TODO determinar onde raio vai ser posicionado o vertex
        //if color == null, then the node is already inserted, only need to change color
        if(color != null)
        {
            lgraph.addVertex(value);
            RandomPositionVertexs(value); //position the vertex in random coords
        }
        else color = Color.GREEN;
        
        //set color for the vertex
        DefaultGraphCell cell = jgraphmodel.getVertexCell( value );
        Map attr = cell.getAttributes();
        GraphConstants.setBackground(attr, color); //change vertex color
        GraphConstants.setGradientColor(attr, Color.BLACK);

        Map cellAttr = new HashMap(  );
        cellAttr.put( cell, cellAttr );
        jgraphmodel.edit(cellAttr, null, null, null);

        
        //RandomPositionVertexs(value);
    }

    public void InsertEdge(String vertex1, String vertex2, String speed)
    {        
        DefaultGraphCell v1 = jgraphmodel.getVertexCell( vertex1 );
        DefaultGraphCell v2 = jgraphmodel.getVertexCell( vertex2 );

        Object[] ed = jgraphmodel.getEdgesBetween(jgraphmodel, v1, v2, true);

        if(ed.length < 1 ) //not found
        {
           lgraph.addEdge(vertex1, vertex2);
        }

        ed = jgraphmodel.getEdgesBetween(jgraphmodel, v1, v2, true);
        for( int i  = 0 ; i < ed.length; i++)
        {
            DefaultGraphCell dgc = (DefaultGraphCell) ed[i];
            int valor = Integer.parseInt(speed);
            String s;
            if(valor > 1000)
                s = valor/1000 + "Kb/s";
            else s = valor + "b/s";

            dgc.setUserObject(s);
        }

        ed = jgraphmodel.getEdgesBetween(jgraphmodel, v1, v2, false);
        for( int i  = 0 ; i < ed.length; i++)
        {
            DefaultGraphCell dgc = (DefaultGraphCell) ed[i];
            int valor = Integer.parseInt(speed);
            String s;
            if(valor > 1000)
                s = valor/1000 + "Kb/s";
            else s = valor + "b/s";

            dgc.setUserObject(s);
        }

    }

    public void RandomPositionVertexs(String vertex)
    {
        
        // get all the vertexs
        Object[] res = JGraphModelAdapter.getAll(jgraphmodel);
        DefaultGraphCell cell = jgraphmodel.getVertexCell( vertex );
        Map attr = cell.getAttributes(  );
        Map mapTmp;
        Rectangle2D b    = (Rectangle2D) GraphConstants.getBounds( attr );
        Rectangle2D recTmp;
        double h = b.getHeight();
        double w = b.getWidth();
        int xfinal;
        int yfinal;
        int xtmp;
        int ytmp;
        boolean conflict = false;
        while(true)
        {
            xfinal = rand.nextInt(getWidth() - (int)b.getWidth());
            yfinal = rand.nextInt(getHeight() - (int)b.getHeight());
            conflict = false;
            for(int i = 0 ; i < res.length; i++)
            {
                DefaultGraphCell dc = (DefaultGraphCell)res[i];
                mapTmp = dc.getAttributes(  );
                recTmp = (Rectangle2D) GraphConstants.getBounds( mapTmp );
                if(recTmp != null)
                {
                    xtmp = (int)recTmp.getX();
                    ytmp = (int)recTmp.getY();
                    
                    //quadrante 1
                    if(xfinal > xtmp && yfinal < ytmp)
                    {
                        if(xfinal < xtmp + 30 + w && yfinal + 30 + h > ytmp)
                            conflict = true;
                    }
                    else
                    //quadrante 2
                    if(xfinal < xtmp && yfinal < ytmp)
                    {
                        if( xfinal + 30 + w > xtmp && yfinal + 30 + h > ytmp )
                            conflict = true;
                    }
                    else
                    //quadrante 3
                    if(xfinal < xtmp && yfinal > ytmp)
                    {
                        if(xfinal + 30 + w > xtmp && yfinal < ytmp + 30 + h)
                            conflict = true;
                    }
                    else
                    //quarante 4
                    if(xfinal > xtmp && yfinal > ytmp)
                    {
                        if(xfinal < xtmp + 30 + w && yfinal < ytmp + 30 + h)
                            conflict = true;
                    }
                    else conflict = true;
                }
            }
            
            if(!conflict)
                break;
        }

        GraphConstants.setBounds( attr, new Rectangle2D.Double(xfinal, yfinal, b.getWidth(), b.getHeight()) );

        Map cellAttr = new HashMap(  );
        cellAttr.put( cell, cellAttr );

        jgraphmodel.edit(cellAttr, null, null, null);
    }
    
}


