
import java.awt.Color;
import java.io.File;
import java.io.IOException;
import java.util.Scanner;
import java.util.Vector;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JOptionPane;
import javax.swing.SwingUtilities;

public class NewJFrame extends javax.swing.JFrame {

    private GraphEngine graph;
    private CommJavaC comm;
    private offlineOperations offline;
    private String fileResultPath;

    public NewJFrame() {
        initComponents();
        fileResultPath = null;
        wiresharkResults.setEnabled(false);

		//  graph = new GraphEngine(jPanel1.getWidth(), jPanel1.getHeight());
		graph = (GraphEngine) jPanel1;
        comm = new CommJavaC();
        offline = new offlineOperations(this, comm);

        //jPanel1.add(graph);

        graph.init();

        Thread t = new Thread(){
            @Override public void run(){
                while(true)
                {
                    try {
                        this.sleep(4000L);
                        Vector<String> result = comm.getNews();

                        if(result != null) //there is something to add
                        {
                            for(int i = 0; i < result.size(); i++)
                            {
                                String action = result.get(i);
                                Scanner scan = new Scanner(action);
                                scan.useDelimiter(";");
                                String command = "";
                                String ip = "";
                                String speed = "";
                                if(scan.hasNext())
                                    command = scan.next();

                                if(command.compareTo("red") == 0)
                                {
                                    ip = scan.next();
                                    graph.InsertVertex(ip, Color.RED);
                                }
                                else
                                if(command.compareTo("green") == 0)
                                {
                                    ip = scan.next();
                                    graph.InsertVertex(ip, Color.GREEN);
                                }
                                else
                                if(command.compareTo("change") == 0)
                                {
                                    ip = scan.next();
                                    graph.InsertVertex(ip, null);
                                }
                                else //is IP;IP;speed
                                {
                                    ip = scan.next();
                                    speed = scan.next();
                                    graph.InsertEdge(command, ip, speed);
                                }
                            }
                        }
  //                      jPanel1.revalidate();
                        //jPanel1.repaint();
			//graph.jgraph.repaint();
			graph.repaint();

//                        jPanel1.updateUI();
                    } catch (InterruptedException ex) {
                        //Logger.getLogger(NewJFrame.class.getName()).log(Level.SEVERE, null, ex);
                       // ex.printStackTrace();
                    }
                }
            };
        };

        t.start();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
        // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
        private void initComponents() {

                buttonGroup1 = new javax.swing.ButtonGroup();
                jPanel1 = new GraphEngine(100,100);
                settingsButton = new javax.swing.JButton();
                startButton = new javax.swing.JButton();
                coloringButton = new javax.swing.JToggleButton();
                pidportTextPanel = new javax.swing.JTextField();
                pidButton = new javax.swing.JRadioButton();
                portButton = new javax.swing.JRadioButton();
                preloadButton = new javax.swing.JRadioButton();
                jSeparator1 = new javax.swing.JSeparator();
                jSeparator2 = new javax.swing.JSeparator();
                jLabel1 = new javax.swing.JLabel();
                remoteCheckBox = new javax.swing.JCheckBox();
                dynamicCheckBox = new javax.swing.JCheckBox();
                filterTextField = new javax.swing.JTextField();
                jLabel2 = new javax.swing.JLabel();
                offlineButton = new javax.swing.JButton();
                wiresharkResults = new javax.swing.JButton();

                setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
                addComponentListener(new java.awt.event.ComponentAdapter() {
                        public void componentResized(java.awt.event.ComponentEvent evt) {
                                onFrameResize(evt);
                        }
                });

                jPanel1.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

                javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
                jPanel1.setLayout(jPanel1Layout);
                jPanel1Layout.setHorizontalGroup(
                        jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                        .addGap(0, 922, Short.MAX_VALUE)
                );
                jPanel1Layout.setVerticalGroup(
                        jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                        .addGap(0, 432, Short.MAX_VALUE)
                );

                settingsButton.setText("Settings");
                settingsButton.addActionListener(new java.awt.event.ActionListener() {
                        public void actionPerformed(java.awt.event.ActionEvent evt) {
                                settingsButtonActionPerformed(evt);
                        }
                });

                startButton.setText("Start");
                startButton.setEnabled(false);
                startButton.addActionListener(new java.awt.event.ActionListener() {
                        public void actionPerformed(java.awt.event.ActionEvent evt) {
                                startButtonActionPerformed(evt);
                        }
                });

                coloringButton.setText("Coloring");
                coloringButton.addActionListener(new java.awt.event.ActionListener() {
                        public void actionPerformed(java.awt.event.ActionEvent evt) {
                                coloringButtonActionPerformed(evt);
                        }
                });

                pidportTextPanel.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
                pidportTextPanel.setEnabled(false);
                pidportTextPanel.setMaximumSize(new java.awt.Dimension(10, 10));
                pidportTextPanel.setMinimumSize(new java.awt.Dimension(10, 10));
                pidportTextPanel.setPreferredSize(new java.awt.Dimension(10, 10));
                pidportTextPanel.addCaretListener(new javax.swing.event.CaretListener() {
                        public void caretUpdate(javax.swing.event.CaretEvent evt) {
                                pidportTextPanelCaretUpdate(evt);
                        }
                });

                buttonGroup1.add(pidButton);
                pidButton.setText("PID");
                pidButton.addActionListener(new java.awt.event.ActionListener() {
                        public void actionPerformed(java.awt.event.ActionEvent evt) {
                                pidButtonActionPerformed(evt);
                        }
                });

                buttonGroup1.add(portButton);
                portButton.setText("PORT");
                portButton.addActionListener(new java.awt.event.ActionListener() {
                        public void actionPerformed(java.awt.event.ActionEvent evt) {
                                portButtonActionPerformed(evt);
                        }
                });

                buttonGroup1.add(preloadButton);
                preloadButton.setText("Preload Library");
                preloadButton.addActionListener(new java.awt.event.ActionListener() {
                        public void actionPerformed(java.awt.event.ActionEvent evt) {
                                preloadButtonActionPerformed(evt);
                        }
                });

                jSeparator1.setOrientation(javax.swing.SwingConstants.VERTICAL);

                jSeparator2.setOrientation(javax.swing.SwingConstants.VERTICAL);

                jLabel1.setText("Monitor by:");

                remoteCheckBox.setText("Remote");

                dynamicCheckBox.setText("Dynamic Graph");

                filterTextField.setText("Capturing All Packets");

                jLabel2.setText("Filter:");

                offlineButton.setText("Offline Operations");
                offlineButton.addActionListener(new java.awt.event.ActionListener() {
                        public void actionPerformed(java.awt.event.ActionEvent evt) {
                                offlineButtonActionPerformed(evt);
                        }
                });

                wiresharkResults.setText("Wireshark Results");
                wiresharkResults.addActionListener(new java.awt.event.ActionListener() {
                        public void actionPerformed(java.awt.event.ActionEvent evt) {
                                wiresharkResultsActionPerformed(evt);
                        }
                });

                javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
                getContentPane().setLayout(layout);
                layout.setHorizontalGroup(
                        layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                        .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                                .addContainerGap()
                                .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                .addContainerGap())
                        .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                                .addGap(24, 24, 24)
                                .addComponent(startButton, javax.swing.GroupLayout.PREFERRED_SIZE, 80, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addGap(18, 18, 18)
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                        .addComponent(remoteCheckBox)
                                        .addComponent(dynamicCheckBox))
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                .addComponent(jSeparator1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addGap(4, 4, 4)
                                .addComponent(jLabel1)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(pidportTextPanel, javax.swing.GroupLayout.PREFERRED_SIZE, 84, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                        .addComponent(pidButton)
                                        .addComponent(portButton))
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                                .addComponent(preloadButton)
                                .addGap(33, 33, 33)
                                .addComponent(jSeparator2, javax.swing.GroupLayout.PREFERRED_SIZE, 22, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(coloringButton)
                                .addGap(18, 18, 18)
                                .addComponent(settingsButton)
                                .addGap(32, 32, 32))
                        .addGroup(layout.createSequentialGroup()
                                .addContainerGap()
                                .addComponent(jLabel2)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(filterTextField)
                                .addGap(18, 18, 18)
                                .addComponent(wiresharkResults)
                                .addGap(38, 38, 38)
                                .addComponent(offlineButton)
                                .addGap(42, 42, 42))
                );
                layout.setVerticalGroup(
                        layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                        .addGroup(layout.createSequentialGroup()
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                                        .addGroup(layout.createSequentialGroup()
                                                .addContainerGap()
                                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                                                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.CENTER)
                                                                .addComponent(startButton)
                                                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.CENTER)
                                                                        .addComponent(jLabel1, javax.swing.GroupLayout.Alignment.LEADING)
                                                                        .addComponent(jSeparator1, javax.swing.GroupLayout.PREFERRED_SIZE, 50, javax.swing.GroupLayout.PREFERRED_SIZE)
                                                                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.CENTER)
                                                                                .addGroup(javax.swing.GroupLayout.Alignment.LEADING, layout.createSequentialGroup()
                                                                                        .addGap(22, 22, 22)
                                                                                        .addComponent(portButton))
                                                                                .addComponent(jSeparator2, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.PREFERRED_SIZE, 50, javax.swing.GroupLayout.PREFERRED_SIZE)
                                                                                .addComponent(pidButton, javax.swing.GroupLayout.Alignment.LEADING)
                                                                                .addGroup(javax.swing.GroupLayout.Alignment.LEADING, layout.createSequentialGroup()
                                                                                        .addGap(10, 10, 10)
                                                                                        .addComponent(pidportTextPanel, javax.swing.GroupLayout.PREFERRED_SIZE, 24, javax.swing.GroupLayout.PREFERRED_SIZE)))))
                                                        .addGroup(layout.createSequentialGroup()
                                                                .addComponent(remoteCheckBox)
                                                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                                                .addComponent(dynamicCheckBox))))
                                        .addGroup(layout.createSequentialGroup()
                                                .addGap(23, 23, 23)
                                                .addComponent(preloadButton))
                                        .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                                                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                                                        .addComponent(settingsButton)
                                                        .addComponent(coloringButton))
                                                .addGap(17, 17, 17)))
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                                        .addComponent(filterTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                        .addComponent(jLabel2)
                                        .addComponent(offlineButton)
                                        .addComponent(wiresharkResults))
                                .addGap(18, 18, 18)
                                .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                .addContainerGap())
                );

                pack();
        }// </editor-fold>//GEN-END:initComponents

    private void coloringButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_coloringButtonActionPerformed
        graph.Coloring(coloringButton.isSelected());
}//GEN-LAST:event_coloringButtonActionPerformed

    private void startButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_startButtonActionPerformed
        if(evt.getActionCommand().compareTo("Start") == 0)
        {
            //clear the graph
            graph.clearAll();
            fileResultPath = null;
            wiresharkResults.setEnabled(false);

            //start monitoring
            int pid = 0;
            int port = 0;
            int remote = 0;
            int dynamic = 0;
            String filter = "";

            if(remoteCheckBox.isSelected())
                remote = 1;

            if(dynamicCheckBox.isSelected())
                dynamic = 1;

            String temp = pidportTextPanel.getText().toString();
            int it = 0;
    
            if(!preloadButton.isSelected())
            {
                try{
                    it = Integer.parseInt(temp);
                }catch(NumberFormatException e){
                    if(pidButton.isSelected())
                        JOptionPane.showMessageDialog(null, "The PID value inserted is not number...");
                    else
                        if(portButton.isSelected())
                            JOptionPane.showMessageDialog(null, "The PORT value inserted is not number...");
                    return;
                }
            }
            if(filterTextField.getText().compareTo("Capturing All Packets") != 0 && filterTextField.getText().length() > 0)
                filter = filterTextField.getText();
            else filter = "";

            if(pidButton.isSelected())
                pid = it;
            else
                if(portButton.isSelected())
                    port = it;

            remoteCheckBox.setEnabled(false);
            dynamicCheckBox.setEnabled(false);
            pidButton.setEnabled(false);
            pidportTextPanel.setEnabled(false);
            preloadButton.setEnabled(false);
            portButton.setEnabled(false);
            filterTextField.setEnabled(false);

            final int tpid = pid;
            final int tport = port;
            final int tremote = remote;
            final int tdynamic = dynamic;
            final String tfilter = filter;
            Thread t = new Thread(){
                @Override public void run(){
                    comm.startMonitoring(tpid, tport, tremote, tdynamic, tfilter);
                }
            };

            t.start();

            startButton.setText("Stop");
            startButton.setActionCommand("Stop");
        }
        else
        if(evt.getActionCommand().compareTo("Stop") == 0)
        {
            //stop monitoring

            startButton.setText("Start");
            startButton.setActionCommand("Start");

            String filePath = comm.stopMonitoring();
            if(filePath != null)
            {
                fileResultPath = filePath;
                wiresharkResults.setEnabled(true);
            }

            remoteCheckBox.setEnabled(true);
            dynamicCheckBox.setEnabled(true);
            pidButton.setEnabled(true);
            pidportTextPanel.setEnabled(true);
            preloadButton.setEnabled(true);
            portButton.setEnabled(true);
            filterTextField.setEnabled(true);
        }
}//GEN-LAST:event_startButtonActionPerformed

    private void settingsButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_settingsButtonActionPerformed

        Settings sp = new Settings(this);
        this.setVisible(false);
        sp.setVisible(true);
    }//GEN-LAST:event_settingsButtonActionPerformed

    private void pidportTextPanelCaretUpdate(javax.swing.event.CaretEvent evt) {//GEN-FIRST:event_pidportTextPanelCaretUpdate
        int p = pidportTextPanel.getText().length();
        if( p > 10)
        {

            SwingUtilities.invokeLater(new Runnable()
            {
            public void run()
            {
                String s = pidportTextPanel.getText().substring(0,10);
                pidportTextPanel.setText(s);
            }
            });
        }
}//GEN-LAST:event_pidportTextPanelCaretUpdate

    private void pidButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_pidButtonActionPerformed
        if(!startButton.isEnabled())
            startButton.setEnabled(true);
        pidportTextPanel.setEnabled(true);
}//GEN-LAST:event_pidButtonActionPerformed

    private void portButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_portButtonActionPerformed
        if(!startButton.isEnabled())
            startButton.setEnabled(true);
        pidportTextPanel.setEnabled(true);
}//GEN-LAST:event_portButtonActionPerformed

    private void preloadButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_preloadButtonActionPerformed
        if(!startButton.isEnabled())
            startButton.setEnabled(true);
        pidportTextPanel.setEnabled(false);
}//GEN-LAST:event_preloadButtonActionPerformed

    private void offlineButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_offlineButtonActionPerformed
       //System.out.println("->" + filterTextField.getText());

       offline.setVisible(true);
       this.setVisible(false);
    }//GEN-LAST:event_offlineButtonActionPerformed

    private void wiresharkResultsActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_wiresharkResultsActionPerformed
        try {
            Runtime.getRuntime().exec("wireshark " + fileResultPath);
        } catch (IOException ex) {
            ex.printStackTrace();
        }
    }//GEN-LAST:event_wiresharkResultsActionPerformed

        private void onFrameResize(java.awt.event.ComponentEvent evt) {//GEN-FIRST:event_onFrameResize
		// TODO add your handling code here:
		//jPanel1.setBackground(Color.red);
	    graph.jgraph.setSize(jPanel1.getWidth(), jPanel1.getHeight()); // vad: hack
	    graph.repaint();
	    //jPanel1.setSize(jPanel1.getWidth()/2, jPanel1.getHeight()); // vad: hack
        }//GEN-LAST:event_onFrameResize


        public static boolean deleteDir(File dir) {
        if (dir.isDirectory()) {
            String[] children = dir.list();
            for (int i=0; i<children.length; i++) {
                boolean success = deleteDir(new File(dir, children[i]));
                if (!success) {
                    return false;
                }
            }
        }

        // The directory is now empty so delete it
        return dir.delete();
    }

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {

        deleteDir(new File("/tmp/remoteMonitor"));
    try {

        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new NewJFrame().setVisible(true);
            }
        });
        }catch(NullPointerException e)
        {
            
        }
    }

        // Variables declaration - do not modify//GEN-BEGIN:variables
        private javax.swing.ButtonGroup buttonGroup1;
        private javax.swing.JToggleButton coloringButton;
        private javax.swing.JCheckBox dynamicCheckBox;
        private javax.swing.JTextField filterTextField;
        private javax.swing.JLabel jLabel1;
        private javax.swing.JLabel jLabel2;
        private javax.swing.JPanel jPanel1;
        private javax.swing.JSeparator jSeparator1;
        private javax.swing.JSeparator jSeparator2;
        private javax.swing.JButton offlineButton;
        private javax.swing.JRadioButton pidButton;
        private javax.swing.JTextField pidportTextPanel;
        private javax.swing.JRadioButton portButton;
        private javax.swing.JRadioButton preloadButton;
        private javax.swing.JCheckBox remoteCheckBox;
        private javax.swing.JButton settingsButton;
        private javax.swing.JButton startButton;
        private javax.swing.JButton wiresharkResults;
        // End of variables declaration//GEN-END:variables
}
